package data.hullmods;

import com.fs.starfarer.api.EveryFrameScript;
import com.fs.starfarer.api.GameState;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseEveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.EveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.input.InputEventAPI;
import java.util.List;
import org.apache.log4j.Logger;

public class CbpsHullmodDisplayBlockScript extends BaseEveryFrameCombatPlugin implements EveryFrameScript {
    private static final Logger Log = Logger.getLogger(CbpsHullmodDisplayBlockScript.class);

    /*private static final String NOTIFICATION_HULLMOD = "cbps_hullmod_conflict";

    private static final String NOTIFICATION_SOUND = "cr_allied_critical";*/

    private static ShipAPI ship;

    public static void showBlocked(ShipAPI blocked) {
        stopDisplaying();
        ship = blocked;
        ship.getVariant().addMod("cbps_hullmod_conflict");
        Global.getSoundPlayer().playUISound("cr_allied_critical", 1.0F, 1.0F);
    }

    public boolean isDone() {
        return false;
    }

    public boolean runWhilePaused() {
        return true;
    }

    public void advance(float amount) {
        stopDisplaying();
    }

    public void advance(float amount, List<InputEventAPI> events) {
        stopDisplaying();
    }

    public void init(CombatEngineAPI engine) {
        if (Global.getSettings().getCurrentState() != GameState.TITLE) {
            stopDisplaying();
            Global.getCombatEngine().removePlugin((EveryFrameCombatPlugin)this);
        }
    }

    public static void stopDisplaying() {
        if (ship != null) {
            Log.debug("Removed from existing ship.");
            ship.getVariant().removeMod("cbps_hullmod_conflict");
            ship = null;
        }
    }
}
